<?php

/**
 * Admin UI
 */

/*
 * Admin settings page
 */



function jstree_admin_settings_form($form, &$form_state) {

  $form = array();

  $menus = _jstree_menu_menus();

  $form['jstree_forms_ids'] = array(
    '#type' => 'textarea',
    '#title' => t('Form CSS IDs'),
    '#rows' => 3,
    '#cols' => 40,
    '#default_value' => variable_get('jstree_forms_ids', '#primary-menu-bar nav'),
    '#description' => t('Enter the CSS IDs/class of the menu containing the UL. One per line. SAMPLE: #block-menu-menu-texturen .content'),
  );

  $form['jstree_id_list'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Add ids to the following menus'),
    '#options' => $menus,
    '#default_value' => variable_get('jstree_id_list', array()),
    '#description' => t('Jstree cookie plugin requires the li element to have a id (or it will not work). Some modules like taxonomy_menu do not add an id. You can enable id adding here. The id will only be added if there isn´t already an id.'),
  );

  $form['jstree']['jstree_size_info'] = array(
    '#markup' => t('<strong>To reduce the filesize of the script, you can remove plugins manually by editing the "jquery.jstree.js" file</strong>'),
  );

  return system_settings_form($form);
}


/**
 * Helper function to get avaliable menus
 *
 * @return $menu_names
 *  array with avaliable menus
 *
 */


function _jstree_menu_menus() {
  if (function_exists('menu_get_menus')) {
    // If the menu module is enabled, list custom menus.
    $menus = menu_get_menus();
  }
  else {
    // Otherwise, list only system menus.
    $menus = menu_list_system_menus();
  }

  // If the book module is enabled, also include book menus.
  if (function_exists('book_get_books')) {
    foreach (book_get_books() as $bid => $link) {
      $menus["book-toc-$bid"] = t('Book: %title', array('%title' => $link['title']));
    }
  }

  // menu_get_names() filters out empty menus, and adds any menus not found using the above calls (edge case).
  foreach (menu_get_names() as $menu) {
    $menu_names[$menu] = isset($menus[$menu]) ? $menus[$menu] : t('Other menu: %menu', array('%menu' => $menu));
  }

  return $menu_names;
}



